/*
Copyright The Volcano Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1alpha1 "volcano.sh/apis/pkg/apis/flow/v1alpha1"
	flowv1alpha1 "volcano.sh/apis/pkg/client/applyconfiguration/flow/v1alpha1"
	scheme "volcano.sh/apis/pkg/client/clientset/versioned/scheme"
)

// JobFlowsGetter has a method to return a JobFlowInterface.
// A group's client should implement this interface.
type JobFlowsGetter interface {
	JobFlows(namespace string) JobFlowInterface
}

// JobFlowInterface has methods to work with JobFlow resources.
type JobFlowInterface interface {
	Create(ctx context.Context, jobFlow *v1alpha1.JobFlow, opts v1.CreateOptions) (*v1alpha1.JobFlow, error)
	Update(ctx context.Context, jobFlow *v1alpha1.JobFlow, opts v1.UpdateOptions) (*v1alpha1.JobFlow, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, jobFlow *v1alpha1.JobFlow, opts v1.UpdateOptions) (*v1alpha1.JobFlow, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.JobFlow, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.JobFlowList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.JobFlow, err error)
	Apply(ctx context.Context, jobFlow *flowv1alpha1.JobFlowApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.JobFlow, err error)
	// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
	ApplyStatus(ctx context.Context, jobFlow *flowv1alpha1.JobFlowApplyConfiguration, opts v1.ApplyOptions) (result *v1alpha1.JobFlow, err error)
	JobFlowExpansion
}

// jobFlows implements JobFlowInterface
type jobFlows struct {
	*gentype.ClientWithListAndApply[*v1alpha1.JobFlow, *v1alpha1.JobFlowList, *flowv1alpha1.JobFlowApplyConfiguration]
}

// newJobFlows returns a JobFlows
func newJobFlows(c *FlowV1alpha1Client, namespace string) *jobFlows {
	return &jobFlows{
		gentype.NewClientWithListAndApply[*v1alpha1.JobFlow, *v1alpha1.JobFlowList, *flowv1alpha1.JobFlowApplyConfiguration](
			"jobflows",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1alpha1.JobFlow { return &v1alpha1.JobFlow{} },
			func() *v1alpha1.JobFlowList { return &v1alpha1.JobFlowList{} }),
	}
}
