/*
Copyright The Volcano Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	v1beta1 "volcano.sh/apis/pkg/apis/scheduling/v1beta1"
	schedulingv1beta1 "volcano.sh/apis/pkg/client/applyconfiguration/scheduling/v1beta1"
	scheme "volcano.sh/apis/pkg/client/clientset/versioned/scheme"
)

// QueuesGetter has a method to return a QueueInterface.
// A group's client should implement this interface.
type QueuesGetter interface {
	Queues() QueueInterface
}

// QueueInterface has methods to work with Queue resources.
type QueueInterface interface {
	Create(ctx context.Context, queue *v1beta1.Queue, opts v1.CreateOptions) (*v1beta1.Queue, error)
	Update(ctx context.Context, queue *v1beta1.Queue, opts v1.UpdateOptions) (*v1beta1.Queue, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, queue *v1beta1.Queue, opts v1.UpdateOptions) (*v1beta1.Queue, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1beta1.Queue, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1beta1.QueueList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.Queue, err error)
	Apply(ctx context.Context, queue *schedulingv1beta1.QueueApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.Queue, err error)
	// Add a +genclient:noStatus comment above the type to avoid generating ApplyStatus().
	ApplyStatus(ctx context.Context, queue *schedulingv1beta1.QueueApplyConfiguration, opts v1.ApplyOptions) (result *v1beta1.Queue, err error)
	QueueExpansion
}

// queues implements QueueInterface
type queues struct {
	*gentype.ClientWithListAndApply[*v1beta1.Queue, *v1beta1.QueueList, *schedulingv1beta1.QueueApplyConfiguration]
}

// newQueues returns a Queues
func newQueues(c *SchedulingV1beta1Client) *queues {
	return &queues{
		gentype.NewClientWithListAndApply[*v1beta1.Queue, *v1beta1.QueueList, *schedulingv1beta1.QueueApplyConfiguration](
			"queues",
			c.RESTClient(),
			scheme.ParameterCodec,
			"",
			func() *v1beta1.Queue { return &v1beta1.Queue{} },
			func() *v1beta1.QueueList { return &v1beta1.QueueList{} }),
	}
}
