/*
Copyright The Volcano Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/listers"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "volcano.sh/apis/pkg/apis/flow/v1alpha1"
)

// JobTemplateLister helps list JobTemplates.
// All objects returned here must be treated as read-only.
type JobTemplateLister interface {
	// List lists all JobTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.JobTemplate, err error)
	// JobTemplates returns an object that can list and get JobTemplates.
	JobTemplates(namespace string) JobTemplateNamespaceLister
	JobTemplateListerExpansion
}

// jobTemplateLister implements the JobTemplateLister interface.
type jobTemplateLister struct {
	listers.ResourceIndexer[*v1alpha1.JobTemplate]
}

// NewJobTemplateLister returns a new JobTemplateLister.
func NewJobTemplateLister(indexer cache.Indexer) JobTemplateLister {
	return &jobTemplateLister{listers.New[*v1alpha1.JobTemplate](indexer, v1alpha1.Resource("jobtemplate"))}
}

// JobTemplates returns an object that can list and get JobTemplates.
func (s *jobTemplateLister) JobTemplates(namespace string) JobTemplateNamespaceLister {
	return jobTemplateNamespaceLister{listers.NewNamespaced[*v1alpha1.JobTemplate](s.ResourceIndexer, namespace)}
}

// JobTemplateNamespaceLister helps list and get JobTemplates.
// All objects returned here must be treated as read-only.
type JobTemplateNamespaceLister interface {
	// List lists all JobTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.JobTemplate, err error)
	// Get retrieves the JobTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.JobTemplate, error)
	JobTemplateNamespaceListerExpansion
}

// jobTemplateNamespaceLister implements the JobTemplateNamespaceLister
// interface.
type jobTemplateNamespaceLister struct {
	listers.ResourceIndexer[*v1alpha1.JobTemplate]
}
